<?php
if (!isset($sshfed_folder)) {
	require_once("../../config.php");
}
require_once($sshfed_folder."/api/Policy.php");

/*
	<SSHServer host="localhost" port="22">
		<WebService address="http://localhost:8888/sshfed_ws/" />
		<Policies>
			<Policy user="root">
				<Attributes check="all" ><!-- all, any or none -->
					<Attribute name="cn" value="John" />
				</Attributes>
			</Policy>
			<Policy user="infoadmin">
				<Attributes check="any" ><!-- all, any or none -->
					<Attribute name="cn" value="John" />
					<Attribute name="sn" value="McCain" />
				</Attributes>
			</Policy>
		</Policies>
	</SSHServer>
*/
class SSHServer {
	private $host;
	private $port;
	private $checkMode;
	private $policies;
	
	public function __construct($xmlElem = "") {
		$this->host = "";
		$this->port = 22;
		$this->checkMode = "";
		$this->policies = array();
		
		if (!is_string($xmlElem)) {
			$this->loadFromXML($xmlElem);
		}
	}
	
	private function loadFromXML($xmlElem) {
		$this->host = $xmlElem["host"];
		$this->port = $xmlElem["port"];
		$this->checkMode = $xmlElem->CheckStatus["value"];
		foreach ($xmlElem->Policies->Policy as $policyXML) {
			$policy = new Policy($policyXML);
			$this->policies[] = $policy;
		}
	}
	
	public function setHost($host) {
		$this->host = $host;
	}
	
	public function getHost() {
		return $this->host;
	}
	
	public function setPort($port) {
		$this->port = $port;
	}
	
	public function getPort() {
		return $this->port;
	}
	
	public function setCheckMode($mode) {
		$this->checkMode = $mode;
	}
	
	public function getCheckMode() {
		$temp = explode(":", $this->checkMode);
		if (count($temp)>=5) {
			return $temp[4];
		}
		else {
			return "none";
		}
	}
	
	public function getCheckModeData() {
		if (strcmp($this->getCheckMode(),"ws")==0||strcmp($this->getCheckMode(),"cron")==0) {
			$temp = explode(":", $this->checkMode);
			return $temp[5];
		}
		else {
			return "";
		}
	}
	
	public function addPolicy($policy) {
		$this->policies[]=policy;
	}
	
	public function setPolicies($policies) {
		$this->policies = $policies;
	}
	
	public function getPolicies() {
		return $this->policies;
	}

}
?>